From eef96dc161bfe0f05cf315c03bdda1d8cd2f4492 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Mar 22 2017 22:58:16 +0000
Subject: [PATCH 810/1001] Implement most of the review comments and add tests


---

diff --git a/hubs/tests/__init__.py b/hubs/tests/__init__.py
index c430043..67d82fa 100644
--- a/hubs/tests/__init__.py
+++ b/hubs/tests/__init__.py
@@ -158,10 +158,21 @@ class FakeAuthorization(object):
         self.username = username
 
 
-# http://flask.pocoo.org/docs/0.11/signals/#subscribing-to-signals
-
 @contextmanager
 def captured_templates(app):
+    """Context manager to inspect rendered templates.
+
+    See http://flask.pocoo.org/docs/0.11/signals/#subscribing-to-signals for
+    usage.
+
+    The argument is the signal emitter.  When calling a core Hubs view, this is
+    the Hubs app (``hubs.app.app`` or ``self.app.application`` if you're in an
+    :py:class:`APPTest` subclass).  If you're calling a widget view, the signal
+    emitter is the widget class, as found in the widgets registry.
+
+    Args:
+        app: The signal emitter.
+    """
     recorded = []
 
     def record(sender, template, context, **extra):
diff --git a/hubs/tests/test_widgets/test_halp.py b/hubs/tests/test_widgets/test_halp.py
index 8950429..81c1831 100644
--- a/hubs/tests/test_widgets/test_halp.py
+++ b/hubs/tests/test_widgets/test_halp.py
@@ -8,14 +8,105 @@ from hubs.tests.test_widgets import WidgetTest
 from hubs.widgets import registry
 
 
+SAMPLE_DATA = [
+    {
+        'author': {
+            'url': '/mattdm/', 'name': 'mattdm', 'avatar': None,
+            },
+        'channel': u'#fedora-meeting',
+        'context_url': (
+            'https://meetbot.fedoraproject.org/fedora-meeting/'
+            '2017-03-17/fesco.2017-03-17-16.00.log.html#l-466'
+            ),
+        'date': 1489773443.0,
+        'meeting_topic': 'FESCO (2017-03-17)',
+        'text': ('"How to enable trim on your SSD drive" would '
+                 'be a good Fedora Magazine article'),
+        'urls': [],
+    }, {
+        'author': {
+            'url': '/jkurik/', 'name': 'jkurik', 'avatar': None,
+            },
+        'channel': '#fedora-meeting-2',
+        'context_url': (
+            'https://meetbot.fedoraproject.org/fedora-meeting-2/2017-03-16/'
+            'f26-alpha-readiness-meeting.2017-03-16-19.00.log.html#l-103'),
+        'date': 1489692368.0,
+        'meeting_topic': 'F26 Alpha Readiness Meeting',
+        'text': ('The Marketing team wants to ask for help from '
+                 'Spins, Labs SIGs and DEs SIGs to populate the '
+                 'talking points that help us to marketing people'),
+        'urls': [],
+    }, {
+        'author': {
+            'url': '/stoney/', 'name': 'stoney', 'avatar': None,
+            },
+        'channel': '#foss2serve',
+        'context_url': (
+            'https://meetbot.fedoraproject.org/foss2serve/2017-03-14/'
+            'posse_irc_meeting_1.2.2017-03-14-17.00.log.html#l-187'),
+        'date': 1489512523.0,
+        'meeting_topic': 'POSSE IRC Meeting 1.2',
+        'text': '',
+        'urls': [],
+    }, {
+        'author': {
+            'url': '/nitzmahone/', 'name': 'nitzmahone', 'avatar': None,
+            },
+        'channel': '#ansible-meeting',
+        'context_url': (
+            'https://meetbot.fedoraproject.org/ansible-meeting/2017-03-14/'
+            'windows_working_group.2017-03-14-00.00.log.html#l-130'),
+        'date': 1489451407.0,
+        'meeting_topic': 'Windows Working Group',
+        'text': '',
+        'urls': [],
+    }, {
+        'author': {
+            'url': '/jborean93/', 'name': 'jborean93', 'avatar': None
+            },
+        'channel': '#ansible-meeting',
+        'context_url': (
+            'https://meetbot.fedoraproject.org/ansible-meeting/2017-03-14/'
+            'windows_working_group.2017-03-14-00.00.log.html#l-59'),
+        'date': 1489450330.0,
+        'meeting_topic': 'Windows Working Group',
+        'text': 'with installers win_msi vs win_product',
+        'urls': [],
+    },
+]
+
+
 class HalpViewsTestCase(WidgetTest):
     plugin = 'halp'  # The name in hubs.widgets.registry
+    maxDiff = None
 
     def setUp(self):
         super(HalpViewsTestCase, self).setUp()
         self.widget = self.widget_instance('ralph', self.plugin)
         config = self.widget.config
         config["hubs"] = ["fedora-devel"]
+        config["per_page"] = 3
+        self.widget.config = config
+        infra_hub = Hub.query.get("infra")
+        infra_hub.config.chat_channel = "#fedora-meeting"
+        devyani7 = Hub.query.get("devyani7")
+        devyani7.config.chat_channel = "#fedora-meeting-2"
+        decause = Hub.query.get("decause")
+        decause.config.chat_channel = "#ansible-meeting"
+        dhrish = Hub.query.get("dhrish")
+        dhrish.config.chat_channel = "#foss2serve"
+        self.session.commit()
+
+    def _get_sample_data_with_hub_keys(self):
+        hub_names = ["infra", "devyani7", "dhrish", "decause", "decause"]
+        data = [req.copy() for req in SAMPLE_DATA]
+        for index, hub_name in enumerate(hub_names):
+            data[index].update({
+                'hub': hub_name,
+                'hubs': [hub_name],
+                })
+        return data
 
     def test_root(self):
         with captured_templates(self.widget.module) as templates:
@@ -23,7 +114,7 @@ class HalpViewsTestCase(WidgetTest):
         self.assertEqual(response.status_code, 200)
         self.assertEqual(len(templates), 1)
         _template, context = templates[0]
-        self.assertEqual(context["hubs"], [])
+        self.assertEqual(context["hubs"], ['fedora-devel'])
 
     def test_json(self):
         response = self.app.get('/ralph/%i/json' % self.widget.idx)
@@ -52,7 +143,10 @@ class HalpViewsTestCase(WidgetTest):
         self.assertEqual(len(templates), 1)
         _template, context = templates[0]
         self.assertEqual(context["mode"], "edit")
-        self.assertEqual(context["initial"], {})
+        self.assertEqual(context["initial"], {
+            'hubs': ['fedora-devel'],
+            'per_page': 3,
+            })
         self.assertEqual(context["url"], "/ralph/%i/edit" % self.widget.idx)
 
     def test_config_hubs_suggest(self):
@@ -62,6 +156,152 @@ class HalpViewsTestCase(WidgetTest):
         self.assertDictEqual(data, {
             'results': ['decause', 'devyani7', 'dhrish', 'i18n', 'infra']
         })
+        response = self.app.get('/w/halp/hubs?q=de')
+        self.assertEqual(response.status_code, 200)
+        data = json.loads(response.get_data(as_text=True))
+        self.assertDictEqual(data, {
+            'results': ['decause', 'devyani7']
+        })
+
+    def test_data(self):
+        expected = self._get_sample_data_with_hub_keys()
+        # Test with no hub selected
+        response = self.app.get('/ralph/w/halp/%i/data' % self.widget.idx)
+        self.assertEqual(response.status_code, 200)
+        data = json.loads(response.get_data(as_text=True))
+        self.assertEqual(data, {"requests": expected[:3]})
+        # Test with the right hub selected
+        response = self.app.get('/ralph/w/halp/%i/data?hubs=decause'
+                                % self.widget.idx)
+        self.assertEqual(response.status_code, 200)
+        data = json.loads(response.get_data(as_text=True))
+        self.assertEqual(data, {"requests": expected[3:5]})
+
+    def test_data_wrong_hub(self):
+        # Test with the wrong hub selected
+        response = self.app.get('/ralph/w/halp/%i/data?hubs=ralph'
+                                % self.widget.idx)
+        self.assertEqual(response.status_code, 200)
+        data = json.loads(response.get_data(as_text=True))
+        self.assertEqual(data, {"requests": []})
+
+    def test_search_requesters(self):
+        response = self.app.get(
+            '/ralph/w/halp/%i/requesters' % self.widget.idx)
+        self.assertEqual(response.status_code, 200)
+        data = json.loads(response.get_data(as_text=True))
+        self.assertDictEqual(data, {
+            'results': ['jborean93', 'jkurik', 'mattdm', 'nitzmahone',
+                        'stoney']
+        })
+        response = self.app.get(
+            '/ralph/w/halp/%i/requesters?q=j' % self.widget.idx)
+        self.assertEqual(response.status_code, 200)
+        data = json.loads(response.get_data(as_text=True))
+        self.assertDictEqual(data, {
+            'results': ['jborean93', 'jkurik']
+        })
+
+    def test_search_all(self):
+        expected = self._get_sample_data_with_hub_keys()
+        response = self.app.get(
+            '/ralph/w/halp/%i/search' % self.widget.idx)
+        self.assertEqual(response.status_code, 200)
+        data = json.loads(response.get_data(as_text=True))
+        self.assertEqual(data, {
+            "requests": expected[:3],
+            'page': {
+                'has_next': True,
+                'has_prev': False,
+                'nr': 1,
+                'total_entries': 5,
+                'total_pages': 2,
+                },
+            })
+        # Page 2
+        response = self.app.get(
+            '/ralph/w/halp/%i/search?page=2' % self.widget.idx)
+        self.assertEqual(response.status_code, 200)
+        data = json.loads(response.get_data(as_text=True))
+        self.assertEqual(data, {
+            "requests": expected[3:],
+            'page': {
+                'has_next': False,
+                'has_prev': True,
+                'nr': 2,
+                'total_entries': 5,
+                'total_pages': 2,
+                },
+            })
+
+    def test_search_hub(self):
+        response = self.app.get(
+            '/ralph/w/halp/%i/search?hubs=infra' % self.widget.idx)
+        self.assertEqual(response.status_code, 200)
+        data = json.loads(response.get_data(as_text=True))
+        expected = self._get_sample_data_with_hub_keys()
+        self.assertEqual(data, {
+            "requests": expected[0:1],
+            'page': {
+                'has_next': False,
+                'has_prev': False,
+                'nr': 1,
+                'total_entries': 1,
+                'total_pages': 1
+                },
+            })
+
+    def test_search_people(self):
+        response = self.app.get(
+            '/ralph/w/halp/%i/search?people=nitzmahone' % self.widget.idx)
+        self.assertEqual(response.status_code, 200)
+        data = json.loads(response.get_data(as_text=True))
+        expected = self._get_sample_data_with_hub_keys()
+        self.assertEqual(data, {
+            "requests": expected[3:4],
+            'page': {
+                'has_next': False,
+                'has_prev': False,
+                'nr': 1,
+                'total_entries': 1,
+                'total_pages': 1
+                },
+            })
+
+    def test_search_meetingname(self):
+        response = self.app.get(
+            '/ralph/w/halp/%i/search?meetingname=Readiness' % self.widget.idx)
+        self.assertEqual(response.status_code, 200)
+        data = json.loads(response.get_data(as_text=True))
+        expected = self._get_sample_data_with_hub_keys()
+        self.assertEqual(data, {
+            "requests": expected[1:2],
+            'page': {
+                'has_next': False,
+                'has_prev': False,
+                'nr': 1,
+                'total_entries': 1,
+                'total_pages': 1
+                },
+            })
+
+    def test_search_date(self):
+        response = self.app.get(
+            '/ralph/w/halp/%i/search?startdate=2017-03-16&enddate=2017-03-17'
+            % self.widget.idx)
+        self.assertEqual(response.status_code, 200)
+        data = json.loads(response.get_data(as_text=True))
+        expected = self._get_sample_data_with_hub_keys()
+        self.assertEqual(data, {
+            "requests": expected[1:2],
+            'page': {
+                'has_next': False,
+                'has_prev': False,
+                'nr': 1,
+                'total_entries': 1,
+                'total_pages': 1
+                },
+            })
 
 
 class HalpFunctionsTestCase(WidgetTest):
@@ -82,6 +322,11 @@ class HalpFunctionsTestCase(WidgetTest):
         infra_hub.config.chat_channel = "#fedora-infra"
         self.session.commit()
 
+    def test_execute(self):
+        with self.app.application.test_request_context('/'):
+            result = self.func.execute()
+        self.assertEqual(result, SAMPLE_DATA)
+
     def test_should_invalidate_wrong_topic(self):
         msg = {'topic': 'hubs.WRONG.TOPIC'}
         result = self.func.should_invalidate(msg)
@@ -105,3 +350,98 @@ class HalpFunctionsTestCase(WidgetTest):
                }
         result = self.func.should_invalidate(msg)
         self.assertTrue(result)
+
+
+class PaginateTestCase(WidgetTest):
+
+    def setUp(self):
+        super(PaginateTestCase, self).setUp()
+        from hubs.widgets.halp.utils import paginate  # circular
+        self.paginate = paginate
+        self.values = ["A", "B", "C", "D"]
+
+    def test_base(self):
+        with self.app.application.test_request_context('/'):
+            result = self.paginate(self.values, 3)
+        self.assertListEqual(result[0], self.values[:3])
+        self.assertDictEqual(result[1], {
+            'has_next': True,
+            'has_prev': False,
+            'nr': 1,
+            'total_entries': len(self.values),
+            'total_pages': 2,
+            })
+
+    def test_page_2(self):
+        with self.app.application.test_request_context('/?page=2'):
+            result = self.paginate(self.values, 3)
+        self.assertListEqual(result[0], self.values[3:])
+        self.assertDictEqual(result[1], {
+            'has_next': False,
+            'has_prev': True,
+            'nr': 2,
+            'total_entries': len(self.values),
+            'total_pages': 2,
+            })
+
+    def test_page_0(self):
+        with self.app.application.test_request_context('/?page=0'):
+            result = self.paginate(self.values, 3)
+        self.assertListEqual(result[0], self.values[:3])
+        self.assertDictEqual(result[1], {
+            'has_next': True,
+            'has_prev': False,
+            'nr': 1,
+            'total_entries': len(self.values),
+            'total_pages': 2,
+            })
+
+    def test_invalid_page(self):
+        with self.app.application.test_request_context('/?page=blah'):
+            result = self.paginate(self.values, 3)
+        self.assertListEqual(result[0], self.values[:3])
+        self.assertDictEqual(result[1], {
+            'has_next': True,
+            'has_prev': False,
+            'nr': 1,
+            'total_entries': len(self.values),
+            'total_pages': 2,
+            })
+
+    def test_page_too_high(self):
+        with self.app.application.test_request_context('/?page=3'):
+            result = self.paginate(self.values, 3)
+        self.assertListEqual(result[0], self.values[3:])
+        self.assertDictEqual(result[1], {
+            'has_next': False,
+            'has_prev': True,
+            'nr': 2,
+            'total_entries': len(self.values),
+            'total_pages': 2,
+            })
+
+    def test_single_page(self):
+        values = self.values[:3]
+        with self.app.application.test_request_context('/'):
+            result = self.paginate(values, 3)
+        self.assertListEqual(result[0], values)
+        self.assertDictEqual(result[1], {
+            'has_next': False,
+            'has_prev': False,
+            'nr': 1,
+            'total_entries': len(values),
+            'total_pages': 1,
+            })
+
+    def test_no_value(self):
+        values = []
+        with self.app.application.test_request_context('/'):
+            result = self.paginate(values, 3)
+        self.assertListEqual(result[0], [])
+        self.assertDictEqual(result[1], {
+            'has_next': False,
+            'has_prev': False,
+            'nr': 1,
+            'total_entries': 0,
+            'total_pages': 1,
+            })
diff --git a/hubs/tests/vcr-request-data/hubs.tests.test_widgets.test_halp.HalpFunctionsTestCase.test_execute b/hubs/tests/vcr-request-data/hubs.tests.test_widgets.test_halp.HalpFunctionsTestCase.test_execute
new file mode 100644
index 0000000..1e03fdc
--- /dev/null
+++ b/hubs/tests/vcr-request-data/hubs.tests.test_widgets.test_halp.HalpFunctionsTestCase.test_execute
@@ -0,0 +1,98 @@
+interactions:
+- request:
+    body: null
+    headers:
+      Accept: ['*/*']
+      Accept-Encoding: ['gzip, deflate']
+      Connection: [keep-alive]
+      User-Agent: [python-requests/2.13.0]
+    method: GET
+    uri: https://apps.fedoraproject.org/datagrepper/raw?topic=org.fedoraproject.prod.meetbot.meeting.item.help&delta=864000
+  response:
+    body:
+      string: !!binary |
+        H4sIAAAAAAAAA+2b+4+qypbH/xXj/HJv9rbl6WMn94dGQUXF5lUo0zedgkJBngK2j5v9v88CtR/7
+        9jmTM3MmOZmYdNJUQa1aa7Gq/HwF/9XE+WYfe0lZNH/8q+ni0tukeeBB6z//+b3ppkmJg+TaIl5U
+        4uaPXoejKOqB+t70EtL8QXN9iqG6dIeuujZ5us886F7jqPC+N2OvGlKNTtLy5Vf7VV+G3RBvPvaU
+        aRa4H9r7wsuvzTQnXt78Aa4UbvN78/PYDA7Bn+/NPD0UL5mXv1x6GP57syhxXlbO9vosx16dfZsI
+        7G4e1h5Jc5zl6dZzywf4Tx5izyudtKz/B8nmISi9+MH3oqwJ07259bNK1D4B8/zFieLiBT68xF5R
+        XB2E7Hp5GayDKgkQwkynyplODzSTyEYgDDUkm7ppyyolmVp9jioHIS3rJkI4VIaqQWibkljdlAWb
+        ioYqSjlCaZplZrPnxKEzGY/trRFKmmbaA9OUWJuRBE9UOqqZDWyKt9RQspEoFShSpwaSzoRSYDT8
+        IUnWlmRq0FJHQ5LynKiGNlYNCWmmzBmmjxzTPlsRKZxYEjXkK2qErueV1DD7uoPsfLVVpvgxk7VQ
+        5ldb+eBI4dlc+uJz4oXSQo3JAoWy4NLawEFZYYXuEfII8wmKaghXaxLMRnBtLfIXTkhrizERTRSJ
+        g8jWzKUgPSeEzkrwRSej+WnF+lMcSjlYz13Lz7Hp8uQsDFRakhC1OmlxGSDmSJuVVSkbL5aRbYnv
+        /j0n5tKcVp7DXANF8kUkmgfD1GxC9U19GSnayD0YyH61RM3UDUHRpIg14kz2TFq0z4KC4j7kGdV5
+        hrx9zPRjJjiSbf5epn8vz8/Jb2V6EE/Oeuz/W6Z/L89gbWkr6vlDpi16O6dt1kZkSmJtODcmUwsR
+        bo4yU136cyeUX21TkwnKSgR5nFNZuqJ8uFYqnxMUZ6F6RsyKobeeeOyoS+0auZIjMdsbW2mrj44Z
+        5FYjj1lYRWZLBBGKNpQl8fUR4Y0RXd+V5+TX+2IuUTXf3kAK3IlMqGr8Y4VjSh7hkZYOomw8XwoB
+        tC81ESvgm5aQrWNER+hZzMVjCdaxFyoDJ8kEI5QTzEopZiKoBvegXtaLoJr9AY4kgTDExtR8atOR
+        BFkonhPX4nWHFSLI0dwe9FUvlCc6rc0WSJFgLe6wdfRdSlq4YTSaU8oAxzJD4lJaLAXORf4efMJm
+        TM9UM3p6TuaP2ZwYQqAPSTCjiYljP7RF9TSjkKSZ5dEeIRmF0VSPJROLR81B2lhPBNYaRaotzo8L
+        w37C44zVJP8Iq17KEDbt0Bwqu0FIMm0o8TZanVVWecVDzVJCX7aSiEMU3bEpLZ0jNJobtj9lxJNq
+        iLQ+UvbTMxFWbAQrC3YeFipDWJl92F3sLeQi0aq9wpRyjRKPyNIkQktDaAuEOlY7j62jTFZRFCiS
+        lGgmPwAbS31UWs8JHs3PmNWQI/ID2MNCZySXKIH7LMlQlcpAe8ywJaaHFSLYlcKTthUw7E7hpYJ9
+        TRHRyKYl5KBHGqwNStsRj7IiZfL07Itzi+b0kWRZon2E6FnwNUQmESDCcBBGrEnJHSQqA8/qC8gS
+        D2os5mYYyRjZe8hbRCJkrnjTjEKVKegZBRXA+MnKknLYNRWw5sPdH8KKmt5WlIXUqWodLSTSmsuS
+        YbUroUjSnhOIjtXDvuaFSDNMkapzZaKBJ9ITZNEjl86Wzoj3NRGtDFNG1/NDLNJPUBkWPmT16oLd
+        fwC7pTU5uaOjPaclThtfKtaI7IG6VEw1vqyY+TKDikYqzHa4WoMdiB5blTVGXhkxr5iGzz4ng1C7
+        7TwH2Hlgb82WZqJt57HC6XEmwMr5ZT0omoZgbw2rPZgUBElg9Yi1c8Q/JxbyBxf/DlPLgJVtVTsR
+        n9hMKShDSbDR5LCQ/AmmEQuz2Zpk6/PREXwnrAorSzdL1jLlAXykTaDelkSGnZGt/dsKar0WYdes
+        9tNLZIrhmsTQYRZNkiQ1lDUEtaeIZKCaIW8nIuzVsoytaAE7kujnRqy9zsVMNJb2q4GijqqXoj2E
+        CMeCAFUxnNJ+vDorUIdSbpzJkojFWQ0jDvI2M7Z+irfKwg61HHyL5C2spqF6fuRW4ZzWKXuhUURf
+        xZqB6Kg0DG2yWkoqltypzgoZ3soDN1KWsIoFdyshBUmxc45sT5RM+JShQ8qhNNtcbk7zkXgyh+ZJ
+        F49QGcLZkaLBjEUr86zstZEk4yTaQ1UbaJOtXFZ40q0SeY9pzQMzE0Gk2uA3aGHzj388J4BFQfNH
+        t9cF+Co2FdXhsgRS87wa8TRc+jhJgIoAUfR0X/penryMgAAjL665xU1JmnhRBJdwAH2bIIrTHIil
+        C+dI5PkxTiqQ+t5cH7wgrnAMsGe7TnOnmoHpQaOIg9KHi4CxtgcHOuEgxJH3Coffm1GQ7I9xSmqU
+        g3YMDhKYu8NVx0ccB1EUpDAJjIrDNKonZIEFgzwIYbYK5zY4ivCmmoOFq84pAUyDRqdiMR8H+edY
+        y3zvfQzl0n7z+dq8en1tVX5fDq+eXxqfHLx0Xf26NN49q9oXdxJIJxDff1wIs3WlyWZF1IDXUe0r
+        JKWiwufmOD00yrThJdiJvEaZB3EjTRqndJ83dH3YIHnw6j03G4d0H5GG4zVwY5OmpCHVthtzvMFn
+        MNUA3A3cyGvW6faSPeSX63QqZ13w9ZZzYGC4hS8XMO52WY5jH6ifFbbXLl5QHC6XRH2waPyNoehu
+        i2JbdPfvMDQ9JDWMv4V8JeoqVLrT6zUmiZvGWeSVXuNvCQRReoDhENXfGwNICmBxI103JKYDA/d5
+        lSG/LLPiR7t94+7PSA6Q3v6cwva7Q3CmcNOH944W3XmgqObPehm8BCBJmvXJNdfxOkyfb5G+x7S4
+        Pt9v9YjTb7Eus4YU4D6DK4eKYJPgcl9VS5PQE0ksZ5Fif6PMTB4U5qQrrIan4d7TS9tPnd0x7gdr
+        hzqu095+GnS6+6cJP6SMbrEcctPe6szuXXbKaKsQtr2eRzaL8rGnyUtKOvRjc7v2x4/a/mRact7m
+        N334zMo0EqfrDraWSfvszWfGhJ+cxyG/2AGTYv3J1HNZGYnL58Q3Z/vs8ajqfs4dXHVo2OZlEyig
+        YlzvJcFxHQIucZLG1XJ9O/UK+qUu4yb10Hngr8UAtyjOPhfE+339wzrp5/e77rnrnrvuueueu+65
+        65677rnrnv9j3cP2vtY9mOD4UEsKp6RqOQH/SVomQbLFdf+7PICT23B/ERvcVQrQFfoH0QbXp2+S
+        pVIoDiiZ/eUwOMcp+PAmCWim+kI4Bya/qJksx6/11+lU9fVwQtK4+hL50kydE9lXbF43Cj+o53yX
+        E53qS2yA96K8jjiyMPWpPnHTP91P8uca8kWXfIr2N/TQNeab0LlEe2tdAr62rjFfW5ewvxBDb7Ff
+        m7fwL82PGbj2vCXh1q7z8JWy+pSNS8ctIf+d8GoxX0ovw/dAPuVhfQ1oFRw3Djgpi0qN4SJsgFps
+        VEzbWOdp3NAziOR7Y4adoqFPRkUDgmkMxWsDhmRpto8AeRugsBsljsLKapYGtUUflxdb+/ra+G3a
+        zEuzz6qNptg31Xa9Q59UW6fPsJ3e16qN6TQeo8zHDc3DBAwWRWP+Jj5v8u3d6HXYWxL+x7qsxbwr
+        s057zXRauHKjld/cuF34rtc6Lbr/pV5zGYencJdqsSxZtzjWpVoOx9Otfp90KabH9gjX/0Wvvebt
+        k8OzvY44HSzQ2bGD46icPfmHMjTm/O4crmxN1gt1OenMtK6UtbX9mVb1jDzNfeMx2b4uvqUrk2zi
+        Wdt4TkSf4ba56Y3Vjr45KYEUjjq55u+P+pr1WJ0r88fNmDtryyf3cZ2/fhMWrxH7KHP9drB6FMfO
+        q7x5QqH4tPE66nMy2eWUtdzbYqFMrHy22zGPf5peu5XCXa/d9dpdr9312l2v3fXaXa/d9dpfWK+x
+        Hf5rvSbgY432oG4GEa6wDrTUQp/McVFUDAQiC4D9dhUgsnvc1df4XkCC6j0guMJPDzgn6/r89fil
+        boT7oojxPqo1FqB2udt7XvKyCRJQPNxF7ry8vNTT7/a4olHQlbmfngDOq+ddeRaEl5eNijJNvNOV
+        0y+Nl/qSEoM8SdPaqbK4yLlTGNb2b4KN+yTYbq5fHzu9+XjTO5eJvpA3aVEwIKNevS+FzSc10eu+
+        qYmrwU9qgqcZnvn6GdDTQtfFxkQb3DREg35gPj4GejN3HXClzD+iIt4CedcPXDuDXu8lyN2Xm0sw
+        8bty4Fp090vlQK9dmup2uq1ut9dtcbyHQTSAkHBdzLiu58Aexf76pMczhdftbrW10iLtURtjPR5B
+        URbmypWKUXgSqCwZG742XKHXJD0oy7gtjoJxuOUV+5zoAqwlIWaUjaORWYUL2mTdNzNfXnj7g0Kv
+        VoijBqFeGh1HN/rUhDY9MXekWMLuTIePIW6jiUFvnRS8OncfPT/femO+u3S0LiyneArn8GjNqhRP
+        YrTlnD/vSc/ttt+Vw1053JXDXTnclcNdOdyVw105/IWVA/Nbb7gRDH1s9U6ak+YeTvpsDe9bHx9C
+        rzikef1qWvWMp6wIOr80kqA8x9hPK2Ku3jC7EfrnN8pq29enJe/Wrx2fJrj23aa4PRx5n+TfMR4n
+        ReBE3u++H/aJ5atX364s/8HyJ57neJqjul/yvBUkJD0UDSvN62cTo+qnGx94/rPJ6yDmgW0AN5b7
+        4g9g/S+BfWT7w8WJl8PFiZf69yMf2b76pckXbM9gj2Y4impxmADb4w7b6nmYbfUdtk/zXYbqU94v
+        bK+lbblcBPYsgo/N3VIWnOV5dZ7mibVzKLoc9vvSaZn5u1mnPy+mvsHSO+ZcRnOW9uU4dGZu6eRL
+        e29qigIAGZfDKU6YwQrZpxl/0D1Fd1LuGz14pSyyOFLHUDjKJz/ivce2/+3gKru0HJ5fy6TfM0/q
+        QXBW64CT1Rk2fEAXUjpOONfgI9p5enTs9slT/zS2v5XAne3vbH9n+zvb39n+zvZ3tr+z/V+a7enf
+        YfveJ/ju/kre/Afs5j8zd/XjlL8o2B+C0m8ECXBbFAHRNQCMX+IiaLxeDitA27vlR/zn++/vBb25
+        /Av8UyxL/f+Df6dLvJ7nMS2P5egWxzq9Vp/vMS3So/vemqF5hia/wP/G2jHRXl0gYTUdbcUndPTm
+        /Vmne0bbdluhe0/lbNfrL+Oz+SqPJ/1AOR8VM15MnGI4eCpzSc4mtNxec2a/mD8nxVJ6GqPlWvkW
+        mABEE13MhqtVZ+Yrw91Ul2ws2x2XI5vDyXpqD0+Z2VG4NpvIdKS0d0e2bLe3JHF7u1NwhPU176X7
+        vhPE8n6UhSZj9YTiT4T/Swn8b+D/n9VgqEsouZ//BWcXbfcxQAAA
+    headers:
+      appserver: [proxy04.fedoraproject.org]
+      apptime: [D=630853]
+      connection: [Keep-Alive]
+      content-encoding: [gzip]
+      content-length: ['4029']
+      content-type: [application/json]
+      date: ['Wed, 22 Mar 2017 18:26:01 GMT']
+      keep-alive: ['timeout=15, max=500']
+      server: [Apache/2.4.6 (Red Hat Enterprise Linux) mod_wsgi/3.4 Python/2.7.5]
+      strict-transport-security: [max-age=15768000; includeSubDomains; preload]
+      vary: [Accept-Encoding]
+    status: {code: 200, message: OK}
+version: 1
